/**
***     TextCtlApp.c
***
***     ̃\[XR[h́AG[XgbvTXyhȂǂ̏Ă܂B
***     Copyright (C) 2006 SophiaCradle Incorporated.
***     All rights reserved.
**/

#include "AEEModGen.h"
#include "AEEAppGen.h"
#include "AEEStdLib.h"
#include "AEEShell.h"
#include "Common.h"
#include "TextCtlApp.bid"
#include "AEEText.h"

#define     TEXT_SIZE       (4096)

typedef struct TextCtlApp {
    AEEApplet a; // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱ƁB
    Common common; // ʕ\p

    ITextCtl* textctl; // ITextCtl C^[tF[X̃CX^Xϐ
    AEERect rect;
} TextCtlApp;

static boolean TextCtlApp_HandleEvent(TextCtlApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam);
static boolean OnAppStart(TextCtlApp* app);
static boolean OnAppStop(TextCtlApp* app);
static boolean OnKey(TextCtlApp* app, uint16 key);
static boolean OnCtlTab(TextCtlApp* app, uint32 dwParam);
static void MakeTextCtl(TextCtlApp* app);

int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
    *ppObj = NULL;
    if (ClsId == AEECLSID_TEXTCTLAPP) {
        if (AEEApplet_New(sizeof(TextCtlApp), ClsId, pIShell, po, (IApplet**)ppObj, (AEEHANDLER)TextCtlApp_HandleEvent, NULL) == TRUE) {
            return AEE_SUCCESS;
        }
    }
    return EFAILED;
}

static boolean TextCtlApp_HandleEvent(TextCtlApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    if (eCode == EVT_APP_START) {
        return OnAppStart(app);
    }
    else if (app->textctl != NULL && ITEXTCTL_HandleEvent(app->textctl, eCode, wParam, dwParam)) {
        return TRUE;
    }
    else {
        switch (eCode) {
            case EVT_APP_STOP:
                return OnAppStop(app);

            case EVT_KEY:
                return OnKey(app, wParam);

            case EVT_CTL_TAB:
                return OnCtlTab(app, dwParam);
        }
    }
    return FALSE;
}

// AvbgJnƂɌĂяoB
static boolean OnAppStart(TextCtlApp* app)
{
    AEEDeviceInfo devinfo;
    IShell* shell = app->a.m_pIShell;
    IDisplay* display = app->a.m_pIDisplay;

    app->textctl = NULL;
    ISHELL_GetDeviceInfo(shell, &devinfo);
    app->rect.x = 20;
    app->rect.y = 20;
    app->rect.dx = devinfo.cxScreen - 40;
    app->rect.dy = 100;

    COMMON_Init(&app->common, display, shell, TEXT_SIZE + 1);
    COMMON_WriteString(&app->common, "Push Select Key");
    COMMON_Draw(&app->common);
    return TRUE;
}

// AvbgIƂɌĂяoB
static boolean OnAppStop(TextCtlApp* app)
{
    if (app->textctl != NULL) {
        ITEXTCTL_Release(app->textctl);
    }
    COMMON_Free(&app->common);
    return TRUE;
}

// L[ꂽƂɌĂяoB
static boolean OnKey(TextCtlApp* app, uint16 key)
{
    switch (key) {
        case AVK_SELECT:
            if (app->textctl == NULL) {
                // eLXgRg[𐶐
                MakeTextCtl(app);
            }
            return TRUE;
    }
    return FALSE;
}

// eLXgRg[J[\OꂽƂ̏
static boolean OnCtlTab(TextCtlApp* app, uint32 dwParam)
{
    if (app->textctl != NULL) {
        COMMON_ClearBuffer(&app->common);
        COMMON_WriteWideString(&app->common, ITEXTCTL_GetTextPtr(app->textctl));
        // Rg[J
        ITEXTCTL_Release(app->textctl);
        app->textctl = NULL;
        // ʕ`
        COMMON_Draw(&app->common);
    }
    return TRUE;
}

// eLXgRg[
static void MakeTextCtl(TextCtlApp* app)
{
    AECHAR* wstr_text;
    int astr_text_len;
    int wstr_text_bytes;
    char string[] = "eLXg";

    app->textctl = NULL;
    ISHELL_CreateInstance(app->a.m_pIShell, AEECLSID_TEXTCTL, (void**)&app->textctl);
    // ő咷ݒ
    ITEXTCTL_SetMaxSize(app->textctl, TEXT_SIZE);

    // `w
    ITEXTCTL_SetRect(app->textctl, &app->rect);

    // ^Cgݒ (char  AECHAR֕ϊ)
    astr_text_len = STRLEN(string);
    wstr_text_bytes = (astr_text_len + 1) * sizeof(AECHAR);
    wstr_text = (AECHAR*) MALLOC(wstr_text_bytes);
    STREXPAND((byte*)string, astr_text_len, wstr_text, wstr_text_bytes);
    ITEXTCTL_SetTitle(app->textctl, NULL, 0, wstr_text);
    FREE(wstr_text);

    // Rg[ݒ
    ITEXTCTL_SetText(app->textctl, app->common.message, -1);

    // vpeBݒ(s, t[ݒ, mȍݒ)
    ITEXTCTL_SetProperties(app->textctl, TP_MULTILINE | TP_FRAME | TP_FIXSETRECT);

    // ANeBuݒ
    ITEXTCTL_SetActive(app->textctl, TRUE);
    return;
}
